
package com.fractalite.hermes.teldar.cfg;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.Date;
import java.util.HashMap;
import java.util.List;

import javax.xml.bind.JAXBContext;
import javax.xml.ws.WebServiceException;

import org.apache.camel.Exchange;
import org.apache.camel.ExchangePattern;
import org.apache.camel.Processor;
import org.apache.camel.builder.RouteBuilder;
import org.apache.camel.converter.jaxb.JaxbDataFormat;
import org.apache.camel.model.language.JXPathExpression;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import com.fractalite.hermes.services.stay.StayRouteBuilder;
import com.fractalite.hermes.teldar.Marshaller.MarshallingJAXB;
import com.fractalite.hermes.teldar.Marshaller.UnmarshallingJAXB;
import com.fractalite.hermes.teldar.parsers.ParseTeldarHotelsPriceResponse;
import com.fractalite.hermes.teldar.services.SearchTeldarHotelPriceRequest;
import com.fractalite.models.commerce.QuoteTemplate;
import com.fractalite.models.travel.stay.HotelStay;
import com.fractalite.models.travel.stay.StaySearchResults;
import com.gekko_holding.webservice.Availability.GetHotelDetailsResponse;
import com.gekko_holding.webservice.Availability.HotelAvailability;
import com.gekko_holding.webservice.Availability.HotelResponse;


public class TeldarRouteBuilder extends RouteBuilder {
	public static final String EP_SEARCH = "teldar/hotel/search";
	public static final String EP_HOTEL_QUOTES = "teldar/hotel/quote";
	public static final String EP_HOTEL_ADDRESSE = "teldar/hotel/addresse";
	public static final String EP_HOTEL_INFO = "teldar/hotel/info";
	public static final String CHEK_AVAILABILITY = "teldar/hotel/chek";
	public static final String BOOK_HOTEL = "teldar/hotel/bookhotel";
	public static final String EP_HOTEL_QUOTE_CANCELLATION_POLICY = "teldar/hotel/hotelQuoteCancelleationFees";
	public static final String EP_CHARGE_CONDITIONS_BOOKING_LINE = "teldar/hotel/chargeConditionsBookingLine";
	public static final String EP_ORDER = "teldar/hotel/Order";
	public static final String EP_GET_ORDER = "teldar/hotel/getOrder";
	public static final String EP_BOOKING_CONFIRMATION = "teldar/hotel/bookingConfirmation";
	public static final String EP_CANCELLATION_FEES = "teldar/hotel/cancelleationFees";
	public static final String EP_CANCEL_ORDER = "teldar/hotel/cancelOrder";
	public static final String EP_MODIFY_ORDER = "teldar/hotel/modifyOrder";
	public static final String EP_MODIFY_ORDER_ITEM = "teldar/hotel/modifyOrderItem";
	public static final String EP_CANCEL_ORDER_ITEM = "teldar/hotel/cancelOrderItem";
	public static final String EP_SEARCH_ORDER = "teldar/hotel/searchOrder";
	public static final String EP_SEARCH_RESULT = "stay/searchResults";
	//public static final String wsUrl = "https4://tld.atlasvoyages.com/gekko-front/ws/v2_4/AvailabilityService";
	public static final String wsUrl = "https4://hermes-teldar.fractalite.com/gekko-front/ws/v2_4/AvailabilityService";
	
	//https4://telder.atlasvoyages.com/gekko-front/ws/v2_4/AvailabilityService
	//https4://teldar.atlasvoyages.com

//    public static final String wsUrl = "http4://hermes-scribe.fractalite.com/gekko-front/ws/v2_4/AvailabilityService";
	// public static final String WSURL_REF =
	// "http4://hermes-scribe.fractalite.com/gekko-front/ws/v2_4/ReferentialService";

	public String status = "";
	// TEST

	// public static final String clientId ="atlasvoyages_test/xml";
	// public static final String password="RmsSj7tbKxUu";

	// PROD

	public static final String clientId = "atlasvoyages/master/test";
	public static final String password = "p*TE*kH!e8$%dS";
	public static final String customerKey ="atlasvoyages/test";

	org.apache.camel.spi.DataFormat jaxb = new org.apache.camel.converter.jaxb.JaxbDataFormat(
			"com.fractalite.hermes.teldar.api");

	private static final Logger logger = LoggerFactory.getLogger(TeldarRouteBuilder.class);

	private JaxbDataFormat hotelsDataFormat;

	private boolean test = false;
	private static HashMap<String, HashMap<String, String>> hmap = new HashMap<String, HashMap<String, String>>();
	private static HashMap<String, String> cities = new HashMap<String, String>();
	// private static List<String> contr=new ArrayList<String>();
	static List<String> list1 = new ArrayList<String>(Arrays.asList("AD", "AE", "AF", "AG", "AI", "AL", "AM", "AO",
			"AR", "AS", "AT", "AU", "AW", "AZ", "BA", "BB", "BD", "BE", "BF", "BG", "BH", "BI", "BJ", "BL", "BM", "BN",
			"BO", "BQ", "BR", "BS", "BT", "BW", "BY", "BZ", "CA", "CD", "CF", "CG", "CH", "CI", "CK", "CL", "CM", "CN",
			"CO", "CR", "CU", "CV", "CW", "CY", "CZ", "DE", "DJ", "DK", "DM", "DO", "DZ", "EC", "EE", "EG", "EH", "ER",
			"ES", "ET", "FI", "FJ", "FK", "FM", "FO", "FR", "GA", "GB", "GD", "GE", "GF", "GH", "GI", "GL", "GM", "GN",
			"GP", "GQ", "GR", "GT", "GU", "GW", "GY", "HK", "HN", "HR", "HT", "HU", "ID", "IE", "IL", "IN", "IQ", "IR",
			"IS", "IT", "JM", "JO", "JP", "KE", "KG", "KH", "KI", "KM", "KN", "KR", "KW", "KY", "KZ", "LA", "LB", "LC",
			"LI", "LK", "LR", "LS", "LT", "LU", "LV", "LY", "MA", "MC", "MD", "ME", "MF", "MG", "MK", "ML", "MM", "MN",
			"MO", "MP", "MQ", "MR", "MS", "MT", "MU", "MV", "MW", "MX", "MY", "MZ", "NA", "NC", "NE", "NF", "NG", "NI",
			"NL", "NO", "NP", "NR", "NU", "NZ", "OM", "PA", "PE", "PF", "PG", "PH", "PK", "PL", "PM", "PR", "PS", "PT",
			"PW", "PY", "QA", "RE", "RO", "RS", "RU", "RW", "SA", "SB", "SC", "SD", "SE", "SG", "SI", "SK", "SL", "SM",
			"SN", "SO", "SR", "SS", "ST", "SV", "SX", "SY", "SZ", "TC", "TD", "TG", "TH", "TJ", "TL", "TM", "TN", "TO",
			"TR", "TT", "TW", "TZ", "UA", "UG", "US", "UY", "UZ", "VC", "VE", "VG", "VI", "VN", "VU", "WF", "WS", "XO",
			"YE", "ZA", "ZM", "ZW"));

	/*
	 * public Object Convertion() throws JAXBException { JAXBContext jaxbContext =
	 * JAXBContext.newInstance(GetHotelDetailsResponse.class); Unmarshaller
	 * unmarshaller = jaxbContext.createUnmarshaller();
	 * 
	 * StringReader reader = new StringReader("xml string here");
	 * GetHotelDetailsResponse person = (GetHotelDetailsResponse)
	 * unmarshaller.unmarshal(reader); return person;
	 * 
	 * }
	 */
	// public static HashMap<String,String> BoardList = new
	// HashMap<String,String>();

	public TeldarRouteBuilder() {

		super();
	}

	/**
	 * Constructor specifying if the routeBuilder is ran as test on production,
	 * public endpoints are exposed through NMR component to enable inter bundle
	 * communication on test , public endpoints are exposed through Direct component
	 * (nmr testing is confusing)
	 *
	 * @param test true if test
	 */
	public TeldarRouteBuilder(boolean test) {

		super();
		this.test = test;
	}

	/*
	 * public static String soapMessageBodyContent(String message) throws Exception
	 * { // create message factory MessageFactory messageFactory =
	 * MessageFactory.newInstance();
	 * 
	 * // converting string body to stream. InputStream responseInputStream = new
	 * ByteArrayInputStream(message.getBytes());
	 * 
	 * // getting saop body stream to create soap message instance SOAPMessage
	 * soapMessage = messageFactory.createMessage(null, responseInputStream);
	 * 
	 * // get the body SOAPBody soapBody = soapMessage.getSOAPBody();
	 * 
	 * return convertToString(soapBody); }
	 */

	/**
	 * Notes on search and quote routes : Since Teldar does not handle multi room
	 * type reservation, split/aggregate is used to make results per each room type
	 */
	@Override
	public void configure() throws Exception {
		String nmrOrDirect = (test) ? "direct:" : "nmr:";

		// XML Data Format
		JaxbDataFormat availabilityReqDF = new JaxbDataFormat();
		JAXBContext context = JAXBContext.newInstance(HotelAvailability.class);
		availabilityReqDF.setContext(context);

		JaxbDataFormat details = new JaxbDataFormat();
		JAXBContext contexts = JAXBContext.newInstance(GetHotelDetailsResponse.class);
		details.setContext(contexts);

		onException(WebServiceException.class)
				// .maximumRedeliveries(2)
				.log("${in.body}").log("${exception}").process(new Processor() {

					@Override
					public void process(Exchange exchange) throws Exception {
						log.info("Teldar IN EP_SEARCH EXCEPTION  ");
						StaySearchResults result = new StaySearchResults();
						result.setQuery(exchange.getIn().getBody(QuoteTemplate.class));
						exchange.getIn().setBody(result);

					}
				});

		/*************** SearchHotelsPriceRequest ******************/

		JAXBContext hotelsContext = JAXBContext.newInstance(HotelResponse.class);
		hotelsDataFormat = new JaxbDataFormat();
		hotelsDataFormat.setContext(hotelsContext);
		hotelsDataFormat.setEncoding("UTF-8");

		long date = new Date().getTime();

		from(nmrOrDirect + EP_SEARCH).routeId(EP_SEARCH).setExchangePattern(ExchangePattern.InOut)
				.log("Contacting search nani !!!!!  ${body}").choice()
				// stop if morocco
				.when(new JXPathExpression("in/body/trip/content[1]/hotel/address/country/code = 'ma'"))
				.process(new Processor() {

					@Override
					public void process(Exchange exchange) throws Exception {
						StaySearchResults result = new StaySearchResults();
						result.setQuery(exchange.getIn().getBody(QuoteTemplate.class));
						exchange.getIn().setBody(result);
					}
				}).to(nmrOrDirect + StayRouteBuilder.EP_SEARCH_RESULT).stop()

			//	.otherwise()

				/*
				 * .process(new Processor() {
				 * 
				 * @Override public void process(Exchange exchange) throws Exception {
				 * QuoteTemplate q = exchange.getIn().getMandatoryBody(QuoteTemplate.class);
				 * HotelStay hotelstay = q.getTrip().getContent(HotelStay.class).get(0); if
				 * (hotelstay.getGiatacode() == null ||
				 * hotelstay.getGiatacode().getGekko_infinite() == null ||
				 * hotelstay.getGiatacode().getGekko_infinite().size() == 0)
				 * exchange.getIn().setHeader("teldaremtygiata", true); else
				 * exchange.getIn().setHeader("teldaremtygiata", false); } })
				 *///.choice()
				// stop if code empty
				/*
				 * .when(header("teldaremtygiata").isEqualTo(true)).
				 * log("Teldar Giata code is null") .removeHeader("teldaremtygiata")
				 */.process(new Processor() {

					@Override
					public void process(Exchange exchange) throws Exception {
						StaySearchResults result = new StaySearchResults();
						result.setQuery(exchange.getIn().getBody(QuoteTemplate.class));
						exchange.getIn().setBody(result);
					}
				}).to(nmrOrDirect + StayRouteBuilder.EP_SEARCH_RESULT).stop()

				.otherwise()
				//.log("Teldar Giata code is NOT null")
				.removeHeaders("CamelHttp*")
				.setHeader(Exchange.HTTP_METHOD, constant(org.apache.camel.component.http4.HttpMethods.POST))
				.setHeader(Exchange.CONTENT_TYPE, constant("application/xml"))
				.setHeader(Exchange.SOAP_ACTION, constant("")).process(new Processor() {

					@Override
					public void process(Exchange exchange) throws Exception {

						for (String h : exchange.getIn().getHeaders().keySet())
							// logger.info("\n header before serach " + h + " : " +
							// exchange.getIn().getHeader(h));
							// TODO Auto-generated method stub
							exchange.setProperty("linkheader", exchange.getIn().getHeader("Link"));
						exchange.setProperty("hermessearchcompletionsize",
								exchange.getIn().getHeader("hermessearchcompletionsize"));
					}
				})

				// .setHeader(Exchange.HTTP_PATH,
				// constant("/api.infinitehotel.com/gekko-front/ws/v2_4"))
				.process(new SearchTeldarHotelPriceRequest())
				.bean(MarshallingJAXB.class, "marshallObject")
				.log("\n Request body content : \n ${body}")

				.to(wsUrl)// + "?throwExceptionOnFailure=false")
				.convertBodyTo(String.class, "ISO-8859-1")
				.log("\n Teldar response body --------------- : \n ${body}")
				.process(new Processor() {
					@Override
					public void process(Exchange exchange) throws Exception {
						exchange.getIn().setHeaders(new HashMap<String, Object>());
						exchange.getIn().setHeader("Link", exchange.getProperty("linkheader"));

						exchange.getIn().setHeader("hermessearchcompletionsize",
								exchange.getProperty("hermessearchcompletionsize"));
						/*
						 * for (String h : exchange.getIn().getHeaders().keySet())
						 * //logger.info("\n header after serach " + h + " :  " +
						 * exchange.getIn().getHeader(h));
						 * logger.info("Unmashalled response body : ---------- \n " +
						 * soapMessageBodyContent(exchange.getIn().getBody(String.class)));
						 */
					}
				})

				/* Unmarshalling accor response */
				.bean(UnmarshallingJAXB.class, "fromHotelAvailabilityResponse(${body})")

				/* Converting accor response. */
				.process(new ParseTeldarHotelsPriceResponse())

				/*
				 * .process(new Processor() {
				 * 
				 * @Override public void process(Exchange exchange) throws Exception {
				 * StaySearchResults staySearchResults = exchange.getIn()
				 * .getMandatoryBody(StaySearchResults.class);
				 * //log.info("\n StaySearchResults size " +
				 * staySearchResults.getHotels().size()); // log.info("\n hotel source " + //
				 * staySearchResults.getHotels().get(0).getMetaFirst("source"));
				 * //log.info("\n query is " +
				 * ObjectToXml.printXML(staySearchResults.getQuery())); } })
				 */

				.end().to(nmrOrDirect + EP_SEARCH_RESULT);
		long datee = new Date().getTime();
		long dif = datee - date;
		// logger.info("dateeeeaccord " + dif);

		/***************** CityHotelRequest *******************/

		/*
		 * from(nmrOrDirect +
		 * EP_HOTEL_ADDRESSE).routeId(EP_HOTEL_ADDRESSE).setExchangePattern(
		 * ExchangePattern.InOut) .removeHeaders("*") .setHeader(Exchange.HTTP_METHOD,
		 * constant(org.apache.camel.component.http4.HttpMethods.POST))
		 * .setHeader(Exchange.CONTENT_TYPE, constant("application/xml"))
		 * .setHeader(Exchange.SOAP_ACTION, constant(""))
		 * .log("ConvertCcities : \n ${body}") .process(new
		 * CityHotelRequest()).log("ConvertCities : \n ${body}")
		 * .bean(MarshallingJAXB.class,
		 * "marshallObject").log("Marshalled body for cities : ${body}")
		 * 
		 * .to(WSURL_REF).convertBodyTo(String.class)
		 * 
		 * .log("Citie Response : \n " + body())
		 * 
		 * .bean(UnmarshallingJAXB.class, "fromGetCitiesResponse(${body})").process(new
		 * Processor() {
		 * 
		 * @Override public void process(Exchange exchange) throws Exception {
		 * exchange.getIn().setHeaders(new HashMap<String, Object>());
		 * 
		 * logger.info("contcity" + getCities(list1)); } })
		 * 
		 * .process(new ParserCityHotelResonse());
		 * 
		 * 
		 * 
		 */

		/***************** HotelQuotesRequest *******************/

		
		  from(nmrOrDirect +
		  EP_HOTEL_QUOTES).routeId(EP_HOTEL_QUOTES)
		  .setExchangePattern(ExchangePattern. InOut) 
		/*
		 * .removeHeaders("*") .setHeader(Exchange.HTTP_METHOD,
		 * constant(org.apache.camel.component.http4.HttpMethods.POST))
		 * .setHeader(Exchange.CONTENT_TYPE, constant("application/xml"))
		 * .setHeader(Exchange.SOAP_ACTION, constant(""))
		 * 
		 * .process(new HotelQuotesRequest()) .process(new Processor() {
		 * 
		 * @Override public void process(Exchange exchange) throws Exception { for
		 * (String h : exchange.getIn().getHeaders().keySet())
		 * logger.info("header before serach " + h + " :  " +
		 * exchange.getIn().getHeader(h));
		 * 
		 * } }) // .log("Converted body -> Quotes : \n ${body}")
		 * .bean(MarshallingJAXB.class, "marshallObject")
		 * //.log("Marshalled body for quotes : ${body}") .to(wsUrl +
		 * "?throwExceptionOnFailure=false")
		 * 
		 * .convertBodyTo(String.class)
		 * //.log("Accorquote response body --------------- : \n ${body}")
		 * 
		 * .process(new Processor() {
		 * 
		 * @Override public void process(Exchange exchange) throws Exception {
		 * exchange.getIn().setHeaders(new HashMap<String, Object>());
		 * logger.info("Unmashalledquote response body : ---------- \n " +
		 * soapMessageBodyContent(exchange.getIn().getBody(String.class))); } })
		 * 
		 * Unmarshalling accor response .bean(UnmarshallingJAXB.class,
		 * "fromHotelAvailabilityResponse(${body})")
		 * 
		 * Converting accor response. .process(new ParserQuotesresponse())
		 * 
		 * 
		 * .process(new Processor() {
		 * 
		 * @Override public void process(Exchange exchange) throws Exception { for
		 * (String h : exchange.getIn().getHeaders().keySet())
		 * logger.info("header after serach3 " + h + " :  " +
		 * exchange.getIn().getHeader(h));
		 * 
		 * } })
		 */;
		 

		/***************** HotelDetailsInfo *******************/

		
		  from(nmrOrDirect +
		  EP_HOTEL_INFO).routeId(EP_HOTEL_INFO)
		  .setExchangePattern(ExchangePattern.InOut) 
		/*
		 * .removeHeaders("*") .setHeader(Exchange.HTTP_METHOD,
		 * constant(org.apache.camel.component.http4.HttpMethods.POST))
		 * .setHeader(Exchange.CONTENT_TYPE, constant("application/xml"))
		 * .setHeader(Exchange.SOAP_ACTION, constant("")).process(new
		 * GetHotelDetailsRequest())
		 * 
		 * .log("bodyDetailss : \n ${body}").bean(MarshallingJAXB.class,
		 * "marshallObject")
		 * 
		 * .to(wsUrl + "?throwExceptionOnFailure=false")
		 * 
		 * .convertBodyTo(String.class, "ISO-8859-1")
		 * 
		 * .log("responseDetailsss --------------- : \n ${body}")
		 * 
		 * .process(new Processor() {
		 * 
		 * @Override public void process(Exchange exchange) throws Exception {
		 * exchange.getIn().setHeaders(new HashMap<String, Object>());
		 * exchange.getIn().setHeader("Link", exchange.getProperty("linkheader"));
		 * exchange.getIn().setHeader("hermessearchcompletionsize",
		 * exchange.getProperty("hermessearchcompletionsize")); for (String h :
		 * exchange.getIn().getHeaders().keySet())
		 * logger.info("headerssssssss after detail " + h + " :  " +
		 * exchange.getIn().getHeader(h));
		 * logger.info("Unmashalled response body : ---------- \n " +
		 * soapMessageBodyContent(exchange.getIn().getBody(String.class))); } })
		 * 
		 * 
		 * .process(new Processor() {
		 * 
		 * @Override public void process(Exchange exchange) throws Exception {
		 * exchange.getIn().setHeaders(new HashMap<String, Object>());
		 * 
		 * logger.info("ConvertionNode" +
		 * ConvertionNode(soapMessageBodyContent(exchange.getIn().getBody(String.class))
		 * )); exchange.getOut().setBody(
		 * ConvertionNode(soapMessageBodyContent(exchange.getIn().getBody(String.class))
		 * )); } })
		 * 
		 * // .bean(UnmarshallingJAXB.class, "fromGetHotelDetailsResponse(${body})")
		 * 
		 * // .bean(Convertion()) .process(new
		 * ParseHoteldetailsResponse()).log("responsemeeee --------------- : \n ${body}"
		 * );
		 * 
		 * 
		 * @Override public void process(Exchange exchange) throws Exception { Hotel
		 * hotel = new Hotel(); hotel.setName("hotelhibis"); hotel.setCode("1234");
		 * hotel.setAddress(new Address("blqblq", "tyty", new Location("PAR", "PARIS"),
		 * new Location("FR", "France"))); hotel.setDescription("hoooooooooo);");
		 * hotel.setEmail("hh@dd.com"); hotel.setLongitude(31.546664f);
		 * hotel.setLatitude(-7.45488f); hotel.addAmenity("paking");
		 * hotel.addAmenity("golf"); List<Image> images = new ArrayList<Image>(); Image
		 * image = new Image("454", "Room",
		 * "http://d3tn4yitxuj2on.cloudfront.net/img/320x180/s3/lectus/2542997/36/a9162bd32f77696c7e4c0594db5af5d9.jpeg",
		 * "http://d3tn4yitxuj2on.cloudfront.net/img/320x180/s3/lectus/2542997/36/a9162bd32f77696c7e4c0594db5af5d9.jpeg",
		 * Short.parseShort("600"), Short.parseShort("600")); images.add(image);
		 * hotel.setImages(images); hotel.setRating(new CodeNamePair("4", "4"));
		 * exchange.getIn().setBody(hotel, Hotel.class); } })
		 */;
		 

		/***************** HotelQuotesCancellationPolicyRequest *******************/

//    	from(nmrOrDirect + EP_HOTEL_QUOTE_CANCELLATION_POLICY).routeId(EP_HOTEL_QUOTE_CANCELLATION_POLICY)
//    	//.tracing()
//    	.split()
//        .method(new QuoteItemsSplitter(), "splitQuoteItemsList").parallelProcessing()
//        .enrich(nmrOrDirect + EP_CHARGE_CONDITIONS_BOOKING_LINE)
//    	.end()
//    	;

		/***************** ChargeConditionsBookingLineRequest *******************/
		/*
		 * from(nmrOrDirect +
		 * EP_CHARGE_CONDITIONS_BOOKING_LINE).routeId(EP_CHARGE_CONDITIONS_BOOKING_LINE)
		 * .setExchangePattern(ExchangePattern.InOut) // .process(new
		 * ChargeConditionsBookingLineRequest()) .log("restel condition rq  ${body}")
		 * .setHeader(Exchange.HTTP_METHOD,
		 * constant(org.apache.camel.component.http4.HttpMethods.POST))
		 * .setHeader(Exchange.CONTENT_TYPE,
		 * constant("application/x-www-form-urlencoded")).to(wsUrl)
		 * .convertBodyTo(String.class,
		 * "ISO-8859-1").log("restel condition rs  ${body}") // .process(new
		 * ParseChargeConditionsBookingLineResponse()) ;
		 */

		/***************** chekavailabilityrequest *******************/
		/*
		 * from(nmrOrDirect +
		 * CHEK_AVAILABILITY).routeId(CHEK_AVAILABILITY).setExchangePattern(
		 * ExchangePattern.InOut) .process(new ChekAvailabilityRequest())
		 * .setHeader(Exchange.HTTP_METHOD,
		 * constant(org.apache.camel.component.http4.HttpMethods.POST))
		 * .setHeader(Exchange.CONTENT_TYPE,
		 * constant("application/x-www-form-urlencoded")).to(wsUrl) // .process(new
		 * ParseHotelQuotesResponse()) .to(nmrOrDirect + CHEK_AVAILABILITY);
		 */

		/***************** bookhotelrequest *******************/

		/*
		 * from(nmrOrDirect +
		 * CHEK_AVAILABILITY).routeId(CHEK_AVAILABILITY).setExchangePattern(
		 * ExchangePattern.InOut) .process(new ChekAvailabilityRequest())
		 * .setHeader(Exchange.HTTP_METHOD,
		 * constant(org.apache.camel.component.http4.HttpMethods.POST))
		 * .setHeader(Exchange.CONTENT_TYPE,
		 * constant("application/x-www-form-urlencoded")).to(wsUrl) // .process(new
		 * ParseHotelQuotesResponse()) .to(nmrOrDirect + CHEK_AVAILABILITY);
		 */

		/*
		 * from(nmrOrDirect + EP_BOOKING_CONFIRMATION) //
		 * from("timer://orderTimer?delay=6000&repeatCount=1")
		 * .routeId(EP_BOOKING_CONFIRMATION).setExchangePattern(ExchangePattern.InOut).
		 * removeHeaders("*") .setHeader(Exchange.HTTP_METHOD,
		 * constant(org.apache.camel.component.http4.HttpMethods.POST))
		 * .setHeader(Exchange.CONTENT_TYPE, constant("application/xml"))
		 * .setHeader(Exchange.SOAP_ACTION, constant("")) .process(new
		 * BookHotelRequest()) .process(new
		 * BookHotelRequest()).bean(MarshallingJAXB.class, "marshallObject")
		 * .log("bookhotelRequest body --------------- : \n ${body}").to(wsUrl).
		 * convertBodyTo(String.class)
		 * .log("bookhotel response body --------------- : \n ${body}")
		 * 
		 * .bean(UnmarshallingJAXB.class, "fromBookHotelResponse(${body})").process(new
		 * ParseBookHotelResponse());
		 */

		/***************** prebookinghotelrequest *******************/

		/*
		 * from(nmrOrDirect + EP_ORDER) //
		 * from("timer://orderTimer?delay=6000&repeatCount=1")
		 * .routeId(EP_ORDER).setExchangePattern(ExchangePattern.InOut).removeHeaders(
		 * "*") .setHeader(Exchange.HTTP_METHOD,
		 * constant(org.apache.camel.component.http4.HttpMethods.POST))
		 * .setHeader(Exchange.CONTENT_TYPE, constant("application/xml"))
		 * .setHeader(Exchange.SOAP_ACTION, constant(""))
		 * 
		 * .process(new BookHotelRequest()) .process(new
		 * AddBookingRequest()).bean(MarshallingJAXB.class, "marshallObject")
		 * .log("prebookRequest body --------------- : \n ${body}")
		 * 
		 * .to(wsUrl)
		 * 
		 * .convertBodyTo(String.class).
		 * log("prebookresponse body --------------- : \n ${body}")
		 * 
		 * .bean(UnmarshallingJAXB.class, "fromPreBookingInfoResponse(${body})")
		 * .process(new ParseAddBookingResponse()).to(nmrOrDirect +
		 * EP_HOTEL_INFO).process(new Processor() {
		 * 
		 * @Override public void process(Exchange exchange) throws Exception { Hotel
		 * hermesHotel = exchange.getIn().getMandatoryBody(Hotel.class); Order order =
		 * exchange.getProperty("order", Order.class);
		 * order.getTrip().getContent(HotelStay.class).get(0).setHotel(hermesHotel);
		 * exchange.getIn().setBody(order, Order.class); } });
		 */
		/***************** getOrder *******************/

		/*
		 * from(nmrOrDirect +
		 * EP_GET_ORDER).routeId(EP_GET_ORDER).setExchangePattern(ExchangePattern.InOut)
		 * .process(new Processor() {
		 *
		 * @Override public void process(Exchange exchange) throws Exception {
		 *
		 * String bookingId = exchange.getIn().getHeader("ReferenceCommande",
		 * String.class); Order order = new Order(); order.setNumber(bookingId);
		 * exchange.getIn().setBody(order);
		 *
		 * } }) // .process(new GetOrderRequest()) .setHeader(Exchange.HTTP_METHOD,
		 * constant(org.apache.camel.component.http4.HttpMethods.POST))
		 * .setHeader(Exchange.CONTENT_TYPE,
		 * constant("application/x-www-form-urlencoded")) //
		 * .log("accor EP_GET_ORDER ${body}") .to(wsUrl) //
		 * .log("accor EP_GET_ORDER ${body}") .convertBodyTo(String.class, "ISO-8859-1")
		 * // .process(new ParseGetOrderResponse()) ;
		 */
		/***************** BookingComfirmationRequest *******************/
		/*
		 * // Mandatory body QuoteTemplate.class from(nmrOrDirect +
		 * EP_BOOKING_CONFIRMATION).routeId(EP_BOOKING_CONFIRMATION).tracing() //
		 * .to("log:output?level=INFO&showAll=true&multiline=true")
		 * .setExchangePattern(ExchangePattern.InOut).setProperty("HermesOrder", new
		 * JXPathExpression("in/body")) // .process(new BookingConfirmationRequest())
		 * .log("body ${body}") .setHeader(Exchange.HTTP_METHOD,
		 * constant(org.apache.camel.component.http4.HttpMethods.POST))
		 * .setHeader(Exchange.CONTENT_TYPE,
		 * constant("application/x-www-form-urlencoded")) // .marshal().gzip()
		 * .to(wsUrl).convertBodyTo(String.class, "ISO-8859-1").log("body ${body}") //
		 * .process(new ParseBookingConfirmationResponse()) .log("body ${body}");
		 */

		/***************** HotelChargeConditionsBookingRequest *******************/

		from(nmrOrDirect + EP_CANCELLATION_FEES).routeId(EP_CANCELLATION_FEES).setExchangePattern(ExchangePattern.InOut)
				.log("AccorCancelFeess --------------- : \n ${body}").process(new Processor() {

					@Override
					public void process(Exchange exchange) throws Exception {
						exchange.getIn().setBody("Please reed cancellation policies");
					}
				});
		/*
		 * .process(new Processor() {
		 * 
		 * @Override public void process(Exchange exchange) throws Exception {
		 * 
		 * log.info("body "+exchange.getIn().getBody()); //Order order =
		 * exchange.getIn().getMandatoryBody(Order.class);
		 * //exchange.setProperty("HermesOrder", order); String
		 * bookingId=exchange.getIn().getHeader("ReferenceCommande", String.class);
		 * Order order = new Order(); order.setNumber(bookingId);
		 * exchange.getIn().setBody(order); log.info("numberrrrr" +bookingId); for
		 * (String h : exchange.getIn().getHeaders().keySet())
		 * logger.info("before after cancelfees " + h + " :  "
		 * +exchange.getIn().getHeader(h));
		 * 
		 * 
		 * } }) .setHeader(Exchange.HTTP_METHOD,
		 * constant(org.apache.camel.component.http4.HttpMethods.POST))
		 * .setHeader(Exchange.CONTENT_TYPE, constant("application/xml"))
		 * .setHeader(Exchange.SOAP_ACTION, constant("")) .process(new
		 * CancelBookingsegmentRequest()) .bean(MarshallingJAXB.class, "marshallObject")
		 * .to(wsUrl) .convertBodyTo(String.class)
		 * .log("AccorCancelFeessresponse body --------------- : \n ${body}")
		 * .bean(UnmarshallingJAXB.class, "fromBookingCancellation(${body})")
		 * .process(new BookingCancellation())
		 */

		/***************** HotelQuotesCancellationPolicyRequest *******************/

		/*
		 * from(nmrOrDirect + EP_HOTEL_QUOTE_CANCELLATION_POLICY).routeId(
		 * EP_HOTEL_QUOTE_CANCELLATION_POLICY)
		 * .setExchangePattern(ExchangePattern.InOut).removeHeaders("*")
		 * .setHeader(Exchange.HTTP_METHOD,
		 * constant(org.apache.camel.component.http4.HttpMethods.POST))
		 * .setHeader(Exchange.CONTENT_TYPE, constant("application/xml"))
		 * .setHeader(Exchange.SOAP_ACTION, constant("")).process(new
		 * QuoteRequestCancellation()) .bean(MarshallingJAXB.class,
		 * "marshallObject").log("cancelRequest body --------------- : \n ${body}")
		 * .to(wsUrl).convertBodyTo(String.class).
		 * log("Cancelresponse body --------------- : \n ${body}")
		 * .bean(UnmarshallingJAXB.class, "fromHotelAvailabilityResponse(${body})")
		 * .process(new QuoteCancellationResponse());
		 */

		/*
		 * from(nmrOrDirect + EP_HOTEL_QUOTE_CANCELLATION_POLICY)
		 * .routeId(EP_HOTEL_QUOTE_CANCELLATION_POLICY) //.tracing() .split()
		 * .method(new com.fractalite.hermes.accor.services.QuoteItemsSplitter(),
		 * "splitQuoteItemsList").parallelProcessing() .enrich(nmrOrDirect +
		 * EP_CHARGE_CONDITIONS_BOOKING_LINE) .end() ;
		 */

		/***************** CancelBookingRequest *******************/

		/*
		 * from(nmrOrDirect +
		 * EP_CANCEL_ORDER).routeId(EP_CANCEL_ORDER).setExchangePattern(ExchangePattern.
		 * InOut) .log("AccorCancelBookingRequest --------------- : \n ${body}")
		 * .setHeader(Exchange.HTTP_METHOD,
		 * constant(org.apache.camel.component.http4.HttpMethods.POST))
		 * .setHeader(Exchange.CONTENT_TYPE, constant("application/xml"))
		 * .setHeader(Exchange.SOAP_ACTION, constant("")).process(new
		 * CancelBookingsegmentRequest()) .convertBodyTo(String.class).
		 * log("Requestbodyyyyy --------------- : \n ${body}") //
		 * .bean(MarshallingJAXB.class, "marshallObject")
		 * .to(wsUrl).convertBodyTo(String.class).
		 * log("AccorCancelBookingRequestbody --------------- : \n ${body}")
		 * .bean(UnmarshallingJAXB.class,
		 * "fromBookingCancellation(${body})").process(new BookingCancellation());
		 */
		/*
		 * .log("ApitudeEpppCancelFees --------------- : \n ${body}") .process(new
		 * Processor() {
		 * 
		 * @Override public void process(Exchange exchange) throws Exception {
		 * 
		 * log.info("body "+exchange.getIn().getBody()); //Order order =
		 * exchange.getIn().getMandatoryBody(Order.class);
		 * //exchange.setProperty("HermesOrder", order); String
		 * bookingId=exchange.getIn().getHeader("ReferenceCommande", String.class);
		 * Order order = new Order(); order.setNumber(bookingId);
		 * exchange.getIn().setBody(order); log.info("numberrrrr" +bookingId); for
		 * (String h : exchange.getIn().getHeaders().keySet())
		 * logger.info("before after cancelfees " + h + " :  "
		 * +exchange.getIn().getHeader(h));
		 * 
		 * 
		 * } }) .setHeader(Exchange.HTTP_METHOD,
		 * constant(org.apache.camel.component.http4.HttpMethods.POST))
		 * .setHeader(Exchange.CONTENT_TYPE, constant("application/xml"))
		 * .setHeader(Exchange.SOAP_ACTION, constant("")) .process(new
		 * CancelBookingsegmentRequest()) .to(wsUrl) .convertBodyTo(String.class)
		 * .log("Cancelresponse body --------------- : \n ${body}") .process(new
		 * BookingCancellation());
		 */
		/*
		 * .process(new CancelBookingsegmentRequest())
		 * 
		 * .bean(MarshallingJAXB.class, "marshallObject")
		 * .log("cancelRequest body --------------- : \n ${body}")
		 * .to(wsUrl).convertBodyTo(String.class)
		 * .log("Cancelresponse body --------------- : \n ${body}")
		 * .bean(UnmarshallingJAXB.class, "fromBookingCancellation(${body})")
		 * .process(new BookingCancellation())
		 */

	}

	/*private static GetHotelDetailsResponse ConvertionNode(String hoteldetail)
			throws ParserConfigurationException, SAXException, IOException, JAXBException, TransformerException {
		Logger logg = LoggerFactory.getLogger(TeldarRouteBuilder.class);
		// Document document = stringToXml(hoteldetail);
		DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
		DocumentBuilder builder;
		builder = factory.newDocumentBuilder();
		Document document = builder.parse(new InputSource(new StringReader(hoteldetail)));
		Element rootElement = document.getDocumentElement();

		GetHotelDetailsResponse resp = new GetHotelDetailsResponse();

		NodeList nLhotelName = rootElement.getElementsByTagName("hotelName");

		Element elmnhotelName = (Element) nLhotelName.item(0);

		Node nLhotelCode = rootElement.getAttributeNode("hotelCode");

		String hotelCode = nLhotelCode.getNodeValue();

		Node nLhotelRating = rootElement.getAttributeNode("hotelRating");

		String hotelRating = nLhotelRating.getNodeValue();

		HotelChain htlChaine = new HotelChain();
		NodeList nLhotelChain = rootElement.getElementsByTagName("hotelChain");

		Element elmnhotelChain = (Element) nLhotelChain.item(0);
		if (elmnhotelChain != null && elmnhotelChain.getTextContent() != null) {
			String hotelChain = elmnhotelChain.getTextContent();
			htlChaine.setValue(hotelChain);
		}

		CityBean cityB = new CityBean();
		NodeList nLcity = rootElement.getElementsByTagName("city");

		Element elmncity = (Element) nLcity.item(0);
		Node nLCode = elmncity.getAttributeNode("code");

		String codeCity = nLCode.getNodeValue();
		cityB.setCode(codeCity);

		GeoLocalization geo = new GeoLocalization();
		NodeList nLgeoLocalization = rootElement.getElementsByTagName("geoLocalization");

		Element elmngeoLocalization = (Element) nLgeoLocalization.item(0);
		Node nLlatitude = elmngeoLocalization.getAttributeNode("latitude");
		double latitude = Double.valueOf(nLlatitude.getNodeValue().toString());
		Node nLlongitude = elmngeoLocalization.getAttributeNode("longitude");
		double longitude = Double.valueOf(nLlongitude.getNodeValue());
		geo.setLatitude(latitude);
		geo.setLongitude(longitude);

		NodeList nLaddress = rootElement.getElementsByTagName("address");

		Element elmnaddress = (Element) nLaddress.item(0);

		NodeList nLphone = rootElement.getElementsByTagName("phone");

		Element elmnphone = (Element) nLphone.item(0);

		NodeList nLfax = rootElement.getElementsByTagName("fax");

		Element elmnfax = (Element) nLfax.item(0);

		NodeList nLemail = rootElement.getElementsByTagName("email");

		Element elmnemail = (Element) nLemail.item(0);

		NodeList nLshortDescription = rootElement.getElementsByTagName("shortDescription");

		Element elmnshortDescription = (Element) nLshortDescription.item(0);

		NodeList nLthumbnailUrl = rootElement.getElementsByTagName("thumbnailUrl");

		Element elmnthumbnailUrl = (Element) nLthumbnailUrl.item(0);

		NodeList nLfacilities = rootElement.getElementsByTagName("facilities");
		Facilities fclt = new Facilities();
		for (int i = 0; i < nLfacilities.getLength(); i++) {
			Facility fac = new Facility();

			Element elmnfacilities = (Element) nLfacilities.item(i);
			NodeList nLfacility = elmnfacilities.getElementsByTagName("facility");
			Element elmnfacility = (Element) nLfacility.item(0);

			Node nLCodeFacilities = elmnfacility.getAttributeNode("code");

			for (int j = 0; j < nLfacility.getLength(); j++) {
				Element elmnFac = (Element) nLfacility.item(j);
				// String typeImage = elmnImage.getNodeValue();
				Node cd = elmnFac.getAttributeNode("code");

				String faci = cd.getNodeValue();
				String facivalue = elmnFac.getTextContent();

				Facility fct = new Facility();
				fct.setCode(faci);
				fct.setValue(facivalue);
				fclt.getFacility().add(fct);
			}
			String codeFacility = nLCodeFacilities.getNodeValue();

			fac.setCode(codeFacility);
			fclt.getFacility().add(fac);

		}

		NodeList nLimages = rootElement.getElementsByTagName("images");
		Images imges = new Images();
		List<ImageUrl> igs = new ArrayList<ImageUrl>();
		List<String> str = new ArrayList<String>();

		for (int i = 0; i < nLimages.getLength(); i++) {
			ImageUrl ig = new ImageUrl();
			Element elmnImages = (Element) nLimages.item(i);
			NodeList nLImage = elmnImages.getElementsByTagName("image");
			Element elmnfacility = (Element) nLImage.item(0);
			Node nLTypeImages = elmnfacility.getAttributeNode("type");

			for (int j = 0; j < nLImage.getLength(); j++) {
				Element elmnImage = (Element) nLImage.item(j);
				// String typeImage = elmnImage.getNodeValue();

				String urlImage = elmnImage.getTextContent();

				// ig.setType(typeImage);
				ig.setValue(urlImage);
				str.add(ig.getValue());
				// imges.getImage().add(j, ig);
				igs.add(ig);

				// logg.info("igggg63" + imges.getImage().get(j).getValue());

			}

		}

		for (int j = 0; j < str.size(); j++) {
			ImageUrl igt = new ImageUrl();
			igt.setValue(str.get(j));
			imges.getImage().add(igt);
		}

		
		 * for(int j= 0; j < igs.size(); j++) { imges.getImage().add(igs.get(j)); }
		 

		
		 * TransformerFactory transformerFactory = TransformerFactory .newInstance();
		 * Transformer transformer = transformerFactory.newTransformer(); DOMSource
		 * source = new DOMSource(s); StreamResult result = new StreamResult(new
		 * StringWriter()); transformer.transform(source, result);
		 

		// String strObject = result.getWriter().toString() ;
		String hotelName = elmnhotelName.getTextContent();
		String city = elmncity.getTextContent();
		String geoLocalization = elmngeoLocalization.getTextContent();
		String address = elmnaddress.getTextContent();
		String phone = elmnphone.getTextContent();
		String fax = "";
		String email = "";
		String shortDescription = "";
		String thumbnailUrl = "";

		if (elmnfax != null && elmnfax.getTextContent() != null)
			fax = elmnfax.getTextContent();

		if (elmnemail != null && elmnemail.getTextContent() != null)
			email = elmnemail.getTextContent();

		if (elmnshortDescription != null && elmnshortDescription.getTextContent() != null)
			shortDescription = elmnshortDescription.getTextContent();

		if (elmnthumbnailUrl != null && elmnthumbnailUrl.getTextContent() != null)
			thumbnailUrl = elmnthumbnailUrl.getTextContent();

		HotelBean htlB = new HotelBean();
		htlB.setHotelName(hotelName);
		htlB.setHotelCode(hotelCode);
		htlB.setHotelRating(hotelRating); //
		htlB.setHotelChain(htlChaine);
		htlB.setAddress(address);
		htlB.setFax(fax);

		htlB.setPhone(phone);
		htlB.setEmail(email);
		htlB.setGeoLocalization(geo);
		htlB.setFacilities(fclt);
		htlB.setImages(imges);
		htlB.setShortDescription(shortDescription);
		htlB.setThumbnailUrl(thumbnailUrl);
		htlB.setCity(cityB);

		resp.getHotel().add(htlB);

		return resp;
	}

	public static Document stringToXml(String line) throws ParserConfigurationException, SAXException, IOException {
		Logger logg = LoggerFactory.getLogger(TeldarRouteBuilder.class);

		DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
		DocumentBuilder builder = factory.newDocumentBuilder();
		Document document = builder.parse(new InputSource(new StringReader(line)));

		return document;
	}

	private static String convertToString(SOAPBody message) throws Exception {
		Document doc = message.extractContentAsDocument();
		Element rootElement = doc.getDocumentElement();
		NodeList nList11 = rootElement.getElementsByTagName("hotel");
		Node m = nList11.item(0);
		Element s = (Element) m;

		StringWriter sw = new StringWriter();
		TransformerFactory tf = TransformerFactory.newInstance();
		Transformer transformer = tf.newTransformer();
		transformer.setOutputProperty(OutputKeys.OMIT_XML_DECLARATION, "yes");
		transformer.setOutputProperty(OutputKeys.METHOD, "xml");
		transformer.setOutputProperty(OutputKeys.INDENT, "yes");
		transformer.setOutputProperty(OutputKeys.ENCODING, "UTF-8");
		transformer.transform(new DOMSource(s), new StreamResult(sw));
		return sw.toString();
	}

	private static HashMap<String, HashMap<String, String>> getPois(List<String> ls)
			throws ParseException, DatatypeConfigurationException {
		// int c=0;
		
		 * for (HotelResponse respHotel : rsp.getHotelResponse()) {
		 * 
		 * if (respHotel.getCity().getCode() != null) {
		 * 
		 * 
		 * cities.put(respHotel.getCity().getCode().substring(2,
		 * 3),CityHotelRequest.getcities(CityHotelRequest.getCity(respHotel.getCity().
		 * getCode().substring(0,2))));
		 * 
		 * } for ( String key : hmap.keySet()) {
		 * 
		 * if (key==respHotel.getCity().getCode()) { c=c+1; } } if(c==0) {
		 * hmap.put(respHotel.getCity().getCode().substring(0, 2), cities); }
		 * cities.clear(); }
		 
		for (int i = 0; i < list1.size(); i++) {
			cities.put(PoiRequest.getPoi(ls.get(i)).getCountryCode(),
					PoiRequest.getPoi(ls.get(i)).getCityCode().toString());

		}

		return hmap;
*/
	//}

}