
package com.fractalite.hermes.teldar.parsers;

import java.io.IOException;
import java.io.StringReader;
import java.net.URL;
import java.security.NoSuchAlgorithmException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;

import javax.xml.bind.JAXBContext;
import javax.xml.bind.Unmarshaller;

import org.apache.commons.lang3.StringUtils;

import com.fasterxml.jackson.dataformat.xml.XmlMapper;
import com.fractalite.hermes.teldar.cfg.TeldarRouteBuilder;
import com.fractalite.models.travel.PaxType;
import com.fractalite.models.travel.Traveller;
import com.fractalite.models.travel.stay.HotelStay;
import com.fractalite.models.travel.stay.Occupancy2;
import com.fractalite.models.travel.stay.Room;
import com.gekko_holding.webservice.Availability.AvailabilityCriteria;
import com.gekko_holding.webservice.Availability.Child;
import com.gekko_holding.webservice.Availability.CityDestination;
import com.gekko_holding.webservice.Availability.CustomerIdentification;
import com.gekko_holding.webservice.Availability.DestinationCriteria;
import com.gekko_holding.webservice.Availability.Facility;
import com.gekko_holding.webservice.Availability.GeoCodeDestination;
import com.gekko_holding.webservice.Availability.HotelAvailability;
import com.gekko_holding.webservice.Availability.HotelCodeDestination;
import com.gekko_holding.webservice.Availability.HotelCodeListDestination;
import com.gekko_holding.webservice.Availability.RoomPlan;
import com.gekko_holding.webservice.Availability.AvailabilityCriteria.RoomCriterias;
import com.gekko_holding.webservice.Availability.AvailabilityResponse;
import com.gekko_holding.webservice.Availability.RoomPlan.Children;




public class AvailabilityTeld {

	public static final String CLIENTID = "atlasvoyages/master/test";
	public static final String PASSWORD = "p*TE*kH!e8$%dS";
	public static final String CUSTOMERKEY = "atlasvoyages/test";

	static {
		System.setProperty("https.protocols", "TLSv1,TLSv1.1,TLSv1.2");
	}
	public static void main(String[] args) throws NoSuchAlgorithmException {

		try {

			String endpoint = "https://api.teldartravel.com/gekko-front/ws/v2_4/AvailabilityService";
			
			URL url = new URL(endpoint);

			HotelAvailability hotelavailability = new HotelAvailability();
			hotelavailability.setLanguage("EN");
			CustomerIdentification customeridentification = new CustomerIdentification();
			customeridentification.setClientId(CLIENTID);
			customeridentification.setPassword(PASSWORD);
			hotelavailability.setIdentification(customeridentification);

			AvailabilityCriteria avaCriteria = new AvailabilityCriteria();
			avaCriteria.setCheckIn("2020-11-16");
			avaCriteria.setCheckOut("2020-11-18");

			DestinationCriteria destinationcriteria = new DestinationCriteria();
			CityDestination citydestination = new CityDestination();
			citydestination.setCode("FRLIO");
			citydestination.setStandard("locode");
			destinationcriteria.setCity(citydestination);
			avaCriteria.setDestinationCriteria(destinationcriteria);

			RoomCriterias roomingList = new RoomCriterias();
			RoomPlan roomPlan = new RoomPlan();
			roomPlan.setAdultsCount(2);
			roomPlan.setRoomType("DOUB");
			

			
			roomingList.getRoomPlan().add(roomPlan);
			avaCriteria.setRoomCriterias(roomingList);

			avaCriteria.setLimit(0);

			hotelavailability.setAvailCriteria(avaCriteria);

		    Utils.constructXml(url, hotelavailability, CLIENTID, PASSWORD);

		} catch (IOException e) {
			System.out.println("the errors : " + e.getMessage());
		}
	}

}
