
package com.fractalite.hermes.teldar.parsers;

import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.net.HttpURLConnection;
import java.net.ProtocolException;
import java.net.URL;

import javax.xml.bind.JAXBContext;
import javax.xml.bind.Marshaller;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.soap.MessageFactory;
import javax.xml.soap.SOAPEnvelope;
import javax.xml.soap.SOAPMessage;
import javax.xml.soap.SOAPPart;

import org.w3c.dom.Document;
import org.w3c.dom.Element;

public class Utils {
	private static final String serverURI = "http://webservice.gekko-holding.com/v2_4";

	public static String constructXml(URL url, Object request, String CLIENTID, String PASSWORD) throws IOException {
		String xml = ""; // /end request xml =
		xml = printXMLPrime(request);
		System.out.println("RequestAvailability= " + xml.toString());
		
		HttpURLConnection connection = construireConnexion(url);

		// Write XML
		OutputStream outputStream = connection.getOutputStream();
		byte[] b = xml.getBytes("UTF-8");
		outputStream.write(b);
		outputStream.flush();
		outputStream.close();

		// Read XML
		InputStream inputStream = connection.getInputStream();
		byte[] res = new byte[2048];
		int i = 0;
		StringBuilder response = new StringBuilder();
		while ((i = inputStream.read(res)) != -1) {
			response.append(new String(res, 0, i));
		}
		inputStream.close();

		System.out.println("ResponseAvailability= " + response.toString());
		return xml;

	}
	
	private static HttpURLConnection construireConnexion(URL url) throws IOException {
		HttpURLConnection connection = (HttpURLConnection) url.openConnection();

		// Set timeout as per needs
		connection.setConnectTimeout(20000);
		connection.setReadTimeout(20000);

		// Set DoOutput to true if you want to use URLConnection for output.
		// Default is false
		connection.setDoOutput(true);

		connection.setUseCaches(true);
		connection.setRequestMethod("POST");

		// Set Headers
		connection.setRequestProperty("Accept", "application/xml");
		connection.setRequestProperty("Content-Type", "application/xml");
		return connection;
	}
	
	public static String printXMLPrime(Object object) {

		DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
		JAXBContext jc;
		String output = "";
		try {
			DocumentBuilder builder = factory.newDocumentBuilder();
			Document document = builder.newDocument();

			jc = JAXBContext.newInstance(object.getClass());
			// Marshaller and properties
			Marshaller marshaller = jc.createMarshaller();
			marshaller.setProperty(Marshaller.JAXB_FORMATTED_OUTPUT, true);
			marshaller.setProperty("jaxb.fragment", Boolean.TRUE);

			marshaller.marshal(object, document);
			SOAPMessage soapMessage = MessageFactory.newInstance().createMessage();

			// Whole envolope of request
			SOAPPart soapPart = soapMessage.getSOAPPart();
			SOAPEnvelope envelope = soapPart.getEnvelope();

			// Teldar namespace uri for prefix
			
			envelope.addNamespaceDeclaration("ns2", serverURI);

			Element documentElement = document.getDocumentElement();

			documentElement.setAttribute("xmlns:ns2", "=http://webservice.gekko-holding.com/v2_4");

			soapMessage.getSOAPBody().addDocument(document);
			ByteArrayOutputStream outputStream = new ByteArrayOutputStream();
			soapMessage.writeTo(outputStream);

			output = new String(outputStream.toByteArray());

			return output;

		} catch (Exception e) {

		}

		return null;

	}

}
