package com.fractalite.hermes.teldar.services;

import java.security.KeyManagementException;
import java.security.NoSuchAlgorithmException;
import java.security.cert.CertificateException;
import java.security.cert.X509Certificate;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.List;

import javax.net.ssl.HttpsURLConnection;
import javax.net.ssl.SSLContext;
import javax.net.ssl.SSLSocketFactory;
import javax.net.ssl.TrustManager;
import javax.net.ssl.X509TrustManager;
import javax.xml.datatype.DatatypeConfigurationException;

import org.apache.camel.Exchange;
import org.apache.camel.InvalidPayloadException;
import org.apache.cxf.jaxrs.client.Client;
import org.apache.http.conn.ClientConnectionManager;
import org.apache.http.conn.scheme.Scheme;
import org.apache.http.conn.scheme.SchemeRegistry;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import com.fractalite.hermes.teldar.Marshaller.MarshallingJAXB;
import com.fractalite.hermes.teldar.cfg.TeldarRouteBuilder;
import com.fractalite.models.commerce.QuoteTemplate;
import com.fractalite.models.travel.PaxType;
import com.fractalite.models.travel.Traveller;
import com.fractalite.models.travel.stay.HotelStay;
import com.fractalite.models.travel.stay.Occupancy2;
import com.fractalite.models.travel.stay.Room;
import com.gekko_holding.webservice.Availability.AvailabilityCriteria;
import com.gekko_holding.webservice.Availability.AvailabilityCriteria.RoomCriterias;
import com.gekko_holding.webservice.Availability.RoomPlan.Children;
import com.gekko_holding.webservice.Availability.Child;
import com.gekko_holding.webservice.Availability.CityDestination;
import com.gekko_holding.webservice.Availability.CustomerIdentification;
import com.gekko_holding.webservice.Availability.DestinationCriteria;
import com.gekko_holding.webservice.Availability.Facility;
import com.gekko_holding.webservice.Availability.GeoCodeDestination;
import com.gekko_holding.webservice.Availability.HotelAvailability;
import com.gekko_holding.webservice.Availability.HotelCodeDestination;
import com.gekko_holding.webservice.Availability.HotelCodeListDestination;
import com.gekko_holding.webservice.Availability.RoomPlan;

public class SearchTeldarHotelPriceRequest extends TeldarServices {

	protected static Logger logger = LoggerFactory.getLogger(SearchTeldarHotelPriceRequest.class);

	@Override
	public void process(Exchange exchange)
			throws InvalidPayloadException, ParseException, DatatypeConfigurationException, KeyManagementException, NoSuchAlgorithmException {

		 logger.trace("\n Invoking teldarrrrr SearchHotelsPriceRequest Processor.......");
			QuoteTemplate q = exchange.getIn().getMandatoryBody(QuoteTemplate.class);
			HotelStay hotelstay = q.getTrip().getContent(HotelStay.class).get(0);
			//HotelStay hotelstay = q.getTrip().getContent(HotelStay.class).get(0);
			exchange.setProperty("hermesquery", q);
			HotelAvailability accorReq = getList(hotelstay);
			logger.info("\n Enddd naniiti SearchHotelsPriceRequest Processor......." + MarshallingJAXB.printXML(accorReq));
			exchange.getIn().setBody(accorReq, HotelAvailability.class);

		}
		public HotelAvailability getList(HotelStay hotelstay) throws ParseException, DatatypeConfigurationException, NoSuchAlgorithmException, KeyManagementException
	    {
		
			
		HotelAvailability hotelavailability=new HotelAvailability();
		hotelavailability.setLanguage("FR");
		CustomerIdentification customeridentification=new CustomerIdentification();
		customeridentification.setClientId(TeldarRouteBuilder.clientId);
		customeridentification.setPassword(TeldarRouteBuilder.password);
	//	customeridentification.setCustomerKey(TeldarRouteBuilder.customerKey);
		hotelavailability.setIdentification(customeridentification);
		
		//AvailabilityCriteria
		AvailabilityCriteria avaCriteria = new AvailabilityCriteria();
		 avaCriteria.setCheckIn("2020-11-16");
	     avaCriteria.setCheckOut("2020-11-18");
	    
	     //DestinationCriteria
	    DestinationCriteria destinationcriteria=new DestinationCriteria();
	    CityDestination citydestination=new CityDestination();
	    citydestination.setCode("FRLIO");
	    citydestination.setStandard("locode");
	  //  citydestination.setRange(3.0);
	    destinationcriteria.setCity(citydestination);
	    avaCriteria.setDestinationCriteria(destinationcriteria);
	    
	    
	    //RoomCriterias
	    RoomCriterias roomingList = new RoomCriterias();
		RoomPlan roomPlan = new RoomPlan();
		roomPlan.setRoomType("DOUB");
		roomPlan.setAdultsCount(2);		
		
		/*
		 * RoomPlan roomPlanPrime = new RoomPlan(); roomPlanPrime.setRoomType("DOUB");
		 * roomPlanPrime.setAdultsCount(2);
		 */	
		/*
		 * Children children = new Children(); Child child = new Child();
		 * child.setAge(10); List<Child> childList = new ArrayList<Child>() ;
		 * childList.add(child); children.getChild().addAll(childList);
		 * roomPlan.setChildren(children);
		 */
		roomingList.getRoomPlan().add(roomPlan );
	//	roomingList.getRoomPlan().add(roomPlanPrime );
		avaCriteria.setRoomCriterias(roomingList);
		
		
		avaCriteria.setLimit(0);
		
		hotelavailability.setAvailCriteria(avaCriteria);
		return hotelavailability;
	}
		}
	/*
	 * public HotelAvailability getList(HotelStay hotelstay) throws ParseException,
	 * DatatypeConfigurationException { HotelAvailability hotelavailability = new
	 * HotelAvailability(); CustomerIdentification customeridentification = new
	 * CustomerIdentification();
	 * 
	 * customeridentification.setClientId("atlasvoyages/xml");
	 * customeridentification.setPassword("9mz%3h/DYV");
	 * 
	 * 
	 * customeridentification.setClientId(AccorRouteBuilder.clientId);
	 * customeridentification.setPassword(AccorRouteBuilder.password);
	 * customeridentification.setCustomerKey(AccorRouteBuilder.customerKey);
	 * 
	 * AvailabilityCriteria avaCriteria = new AvailabilityCriteria();
	 * SimpleDateFormat formatter = new SimpleDateFormat("yyyy-mm-dd");
	 * 
	 * hotelavailability.setIdentification(customeridentification);
	 * 
	 * // GetHotelDetails gethoteldetails=new GetHotelDetails();
	 * 
	 * 
	 * DestinationCriteria destinationcriteria = new DestinationCriteria();
	 * 
	 * HotelCodeDestination hotelcodedestination=new HotelCodeDestination();
	 * hotelcodedestination.setCode(hotelstay.getHotel().getAddress().getLocality().
	 * getCode()); destinationcriteria.setHotel(hotelcodedestination);
	 * 
	 * DestinationCriteria destinationcriteria = new DestinationCriteria(); //
	 * CityDestination citydestination = new CityDestination(); //
	 * citydestination.setCode(hotelstay.getHotel().getAddress().getLocality().
	 * getCode()); //
	 * logger.info("codeeee"+hotelstay.getHotel().getAddress().getLocality().getCode
	 * ());
	 * 
	 * 
	 * citydestination.setCode("FRLIO"); citydestination.setStandard("locode");
	 * destinationcriteria.setCity(citydestination);
	 * 
	 * String desCode = hotelstay.getHotel().getAddress().getLocality().getCode();
	 * logger.info("loccccc" + desCode); if (desCode.contains("geo-")) { String[]
	 * geos = desCode.split("-"); GeoCodeDestination geo = new GeoCodeDestination();
	 * geo.setLatitude(Double.parseDouble(geos[2]));
	 * geo.setLongitude(Double.parseDouble(geos[2]));
	 * geo.setRange(Double.parseDouble("2")); destinationcriteria.setGeoCode(geo);
	 * avaCriteria.setDestinationCriteria(destinationcriteria);
	 * 
	 * } else { // Search By hotels codes
	 * 
	 * HotelCodeListDestination hotelsList = new HotelCodeListDestination();
	 * //if(hotelstay.getGiatacode() == null ||
	 * hotelstay.getGiatacode().getGekko_infinite() == null ||
	 * hotelstay.getGiatacode().getGekko_infinite().size() == 0) // d for (String
	 * hotelcodes : hotelstay.getGiatacode().getGekko_infinite()) { String[] codes =
	 * hotelcodes.split("-"); String supplierCode = codes[0]; String giataCode =
	 * codes[1]; HotelCodeDestination hcode = new HotelCodeDestination();
	 * hcode.setCode(supplierCode); hotelsList.getHotel().add(hcode); }
	 * 
	 * destinationcriteria.setHotels(hotelsList);
	 * avaCriteria.setDestinationCriteria(destinationcriteria); } //
	 * hotelstay.getLocation().getCode();
	 * 
	 * hotelavailability.setLanguage("EN");
	 * 
	 * // logger.info("chekout is" +hotelstay.getCheckin());
	 * avaCriteria.setCheckIn(hotelstay.getCheckin().toString());
	 * avaCriteria.setCheckOut(hotelstay.getCheckout().toString());
	 * 
	 * RoomCriterias crit = new RoomCriterias();
	 * 
	 * // Room rooms = new Room(); String roo = ""; for (Room chambre :
	 * hotelstay.getRooms()) { // Log.info("rooooooooommm "
	 * +hotelstay.getRooms().size());
	 * 
	 * Occupancy2 occupancy = new Occupancy2(); RoomPlan roomoffers = new
	 * RoomPlan();
	 * 
	 * int nbreOfAdult = 0; Children chlidren = new Children(); for (Traveller
	 * traveller : chambre.getGuests()) {
	 * 
	 * if (traveller.getClassification() == PaxType.ADULT) nbreOfAdult++; else if
	 * (traveller.getClassification() == PaxType.CHILD) { Child child = new Child();
	 * child.setAge(traveller.getAge()); chlidren.getChild().add(child); }
	 * 
	 * } occupancy.setAdults(nbreOfAdult); roomoffers.setRoomType(roo);
	 * roomoffers.setAdultsCount(nbreOfAdult); roomoffers.setChildren(chlidren);
	 * roomoffers.getRoomType(); crit.getRoomPlan().add(roomoffers);
	 * 
	 * }
	 * 
	 * avaCriteria.setRoomCriterias(crit);
	 * 
	 * hotelavailability.setAvailCriteria(avaCriteria);
	 * 
	 * 
	 * RoomCriterias roomingList = new RoomCriterias(); RoomPlan roomPlan = new;
	 * RoomPlan(); roomPlan.setAdultsCount(2); roomPlan.setRoomType("DOUB");
	 * roomingList.getRoomPlan().add(roomPlan );
	 * 
	 * 
	 * avaCriteria.setRoomCriterias(roomingList);
	 * hotelavailability.setLanguage("EN");
	 * 
	 * return hotelavailability;
	 * 
	 * //
	 * roomPlan.setAdultsCount(hotelstay.getTravellers().get(0).getClassification().
	 * equals(PaxType.ADULT));
	 * 
	 * Children children = new Children(); Child child = new Child();
	 * child.setAge(5); children.getChild().add(child);
	 * roomPlan.setChildren(children );
	 * 
	 * 
	 * 
	 * Children children = new Children(); Child child = new Child();
	 * child.setAge(5); children.getChild().add(child); Child child2 = new Child();
	 * child2.setAge(1); children.getChild().add(child2);
	 * roomPlan.setChildren(children );
	 * 
	 * 
	 * }
	 * 
	 * }
	 */